# coding: latin-1

import urllib2
from BeautifulSoup import BeautifulSoup
 
# Erstellen/öffnen Sie eine Datei mit dem Namen wunder-data.txt. 
# Dies wird eine kommaseparierte Datei sein.
f = open('wunder-data.txt', 'w')
 
# Durchlaufen Sie die einzelnen Jahre, Monate und Tage
for y in range(2009, 2010):
  for m in range(1, 13):
    for d in range(1, 32):
 
      # Auf Schaltjahr prüfen
      if y%400 == 0:
        leap = True
      elif y%100 == 0:
        leap = False
      elif y%4 == 0:
        leap = True
      else:
        leap = False

      # Prüfen, ob bereits der letzte Tag eines 
      # Monats bearbeitet wurde 
     if (m == 2 and leap and d > 29):
        continue
      elif (m == 2 and d > 28):
        continue
      elif (m in [4, 6, 9, 10] and d > 30):
        continue
 
      # Öffnen Sie die wunderground.com URL
      url = "http://www.wunderground.com/history/airport/EHAM/"+str(y)+ "/" + str(m) + "/" + str(d) + "/DailyHistory.html"
      page = urllib2.urlopen(url)
 
      # Temperatur aus Seite extrahieren
      soup = BeautifulSoup(page)
      # dayTemp = soup.body.nobr.b.string
      dayTemp = soup.findAll(attrs={"class":"nobr"})[3].span.string
 
      # Monat für Zeitstempel formatieren
      if len(str(m)) < 2:
        mStamp = '0' + str(m)
      else:
        mStamp = str(m)
 
      # Tag für Zeitstempel formatieren
      if len(str(d)) < 2:
        dStamp = '0' + str(d)
      else:
        dStamp = str(d)
 
      # Zeitstempel zusammenbauen
      timestamp = str(y) + mStamp + dStamp
 
      # Zeitstempel und Temperatur in Datei schreiben
      f.write(timestamp + ',' + dayTemp + '\n')
 
# Alle Daten sind extrahiert! Datei schließen.
f.close()
