# Daten laden
hotdogs <- read.csv("data/hot-dog-contest-winners.csv", sep=",", header=TRUE)

# Standardsäulendiagramm
barplot(hotdogs$Dogs.eaten)

# Jahre anzeigen
barplot(hotdogs$Dogs.eaten, names.arg=hotdogs$Year)

# Achsen beschriften
barplot(hotdogs$Dogs.eaten, names.arg=hotdogs$Year, xlab="Jahr", ylab="Gegessene Hotdogs")

# Füllfarbe und Rahmen festlegen
barplot(hotdogs$Dogs.eaten, names.arg=hotdogs$Year, col="red", border=NA, xlab="Year", ylab="Gegessene Hotdogs")


# Jahre hervorheben, in denen die USA gewannen
fill_colors <- c()
for ( i in 1:length(hotdogs$Country) ) {
	if (hotdogs$Country[i] == "United States") {
		fill_colors <- c(fill_colors, "#821122")
	} else {
		fill_colors <- c(fill_colors, "#cccccc")
	}
}
barplot(hotdogs$Dogs.eaten, names.arg=hotdogs$Year, col=fill_colors, border=NA, xlab="Year", ylab="Gegessene Hotdogs")


# Jahre mit neuem Rekord hervorheben
fill_colors <- c()
for ( i in 1:length(hotdogs$New.record) ) {
	if (hotdogs$New.record[i] == 1) {
		fill_colors <- c(fill_colors, "#821122")
	} else {
		fill_colors <- c(fill_colors, "#cccccc")
	}
}
barplot(hotdogs$Dogs.eaten, names.arg=hotdogs$Year, col=fill_colors, border=NA, xlab="Jahr", ylab="Gegessene Hotdogs")


# Abstände anpassen
barplot(hotdogs$Dogs.eaten, names.arg=hotdogs$Year, col=fill_colors, border=NA, space=0.3, xlab="Jahr", ylab="Gegessene Hotdogs", main="Internationales Hotdog-Wettessen, Ergebnisse 1980-2010")

barplot(hotdogs$Dogs.eaten, names.arg=hotdogs$Year, col=fill_colors, border=NA, space=0.5, xlab="Jahr", ylab="Gegessene Hotdogs")

# Titel ergänzen
barplot(hotdogs$Dogs.eaten, names.arg=hotdogs$Year, col=fill_colors, border=NA, space=0.25, xlab="Jahr", ylab="Gegessene Hotdogs", main="Internationales Hotdog-Wettessen, Ergebnisse 1980-2010")


